VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDirectSound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' clsDirectSound.cls

' This code NOT developed by Michael Kudlo
' Original author unknown.


Option Explicit

Dim DSound As DirectSound

Dim Sounds() As DirectSoundBuffer

Dim BufferDesc As DSBUFFERDESC
Dim WaveFormat As WAVEFORMATEX

Dim PrimDesc As DSBUFFERDESC

Dim CurPosition As Long

Public Function Init(DirectX As DirectX7, Form As Form, SoundNumber As Byte) As Boolean
On Error GoTo DSErr

Set DSound = DirectX.DirectSoundCreate("")
DSound.SetCooperativeLevel Form.hWnd, DSSCL_NORMAL

BufferDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC Or DSBCAPS_GLOBALFOCUS

WaveFormat.nFormatTag = WAVE_FORMAT_PCM
WaveFormat.nChannels = 2
WaveFormat.lSamplesPerSec = 22050
WaveFormat.nBitsPerSample = 16
WaveFormat.nBlockAlign = WaveFormat.nBitsPerSample / 8 * WaveFormat.nChannels
WaveFormat.lAvgBytesPerSec = WaveFormat.lSamplesPerSec * WaveFormat.nBlockAlign

ReDim Sounds(1 To SoundNumber)

Init = True
Exit Function

DSErr:
'MsgBox "Unable to start DirectSound. Check to see that your sound card, and DirectX are properly installed"
Init = False

End Function

Public Function Load(File As String, Index As Byte) As Boolean
On Error GoTo DSErr

Set Sounds(Index) = DSound.CreateSoundBufferFromFile(File, BufferDesc, WaveFormat)

Load = True
Exit Function

DSErr:
MsgBox "Unable to load this sample. Check to see if it's in PCM format. : " & Err.Description
Load = False

End Function

Public Sub SoundPlay(Index As Byte, Looping As CONST_DSBPLAYFLAGS)
    If Index <= 0 Then Exit Sub
If Sounds(Index) Is Nothing Then Exit Sub
    
    Sounds(Index).SetCurrentPosition CurPosition
    Sounds(Index).Play Looping
End Sub

Public Sub SetVolume(Index As Byte, NewVolume As Long)
If Sounds(Index) Is Nothing Then Exit Sub

If NewVolume <= 0 And NewVolume >= -10000 Then
    Sounds(Index).SetVolume NewVolume
End If

End Sub

Public Function GetVolume(Index As Byte) As Long
If Sounds(Index) Is Nothing Then
    GetVolume = -1
    Exit Function
End If

GetVolume = Sounds(Index).GetVolume

End Function

Public Sub SetPanning(Index, NewPanning As Long)
If Sounds(Index) Is Nothing Then Exit Sub

If NewPanning <= 10000 And NewPanning >= -10000 Then
    Sounds(Index).SetPan NewPanning
End If

End Sub

Public Function GetPanning(Index As Byte) As Long
If Sounds(Index) Is Nothing Then
    GetPanning = -1
    Exit Function
End If

GetPanning = Sounds(Index).GetPan

End Function

Public Sub SoundStop(Index As Byte)
If Sounds(Index) Is Nothing Then Exit Sub
    
    CurPosition = 0
    Sounds(Index).Stop
End Sub

Public Sub SoundPauze(Index As Byte)
Dim Cursors As DSCURSORS

If Sounds(Index) Is Nothing Then Exit Sub
    
    
    Sounds(Index).GetCurrentPosition Cursors
    Sounds(Index).Stop

    CurPosition = Cursors.lPlay
End Sub

Private Sub Class_Initialize()
    CurPosition = 0
End Sub
