Attribute VB_Name = "modFile"
Option Explicit



Sub modFile_Save(Filename As String)
    On Error GoTo Error_modFile_Save
    
    ' create a saved folder
    If Dir(App.Path & "/saved", vbDirectory) = "" Then
        MkDir App.Path & "/saved"
    End If
    
    Dim filenum As Integer, i As Long
    
    filenum = FreeFile()
    
    Open App.Path & "/saved/" & Filename & ".saved" For Binary As filenum
    
    ' probably should place a header here with version info
    
    ' players
    i = UBound(Player)
    Put #filenum, , i       ' saved the size
    Put #filenum, , Player  ' save the whole array
    
    ' items
    i = UBound(Item)
    Put #filenum, , i       ' saved the size
    Put #filenum, , Item  ' save the whole array
    
    ' no need to save item or player maps since the individuals have the xpos, ypos data in them
    
    Close filenum
    
    Exit Sub
    
Error_modFile_Save:
    MsgBox "Error_modFile_Save : " & Err.Description
End Sub


Sub modFile_Load(Filename As String)
    On Error GoTo Error_modFile_Load
    
    Dim filenum As Integer, i As Long
    
    filenum = FreeFile()
    
    'Open App.Path & "/saved/" & Filename & ".saved" For Binary As filenum
    Open Filename For Binary As filenum
    
    ' probably should load a header here with version info
    
    
    ' players
    Get #filenum, , i       ' load the size
    ReDim Player(1 To i)    ' resize and clear to fit
    Get #filenum, , Player  ' load the whole array
    
    ' items
    Get #filenum, , i       ' load the size
    ReDim Item(1 To i)      ' resize and clear to fit
    Get #filenum, , Item    ' load the whole array
    
    Close filenum
    
    ' create maps
    ReDim ItemMap(100, 100)
    ReDim PlayerMap(100, 100)
    ReDim VisibleMap(100, 100)
    ReDim LightMap(100, 100)
    
    
    ' rebuild player map
    For i = 1 To UBound(Player)
        If Player(i).flgInUse Then
            PlayerMap(Player(i).Xpos, Player(i).Ypos) = i
            
            ' look for the users player
            If Player(i).ID = 0 Then
                Game.pIndex = i
                Game.ViewXpos = Player(i).Xpos
                Game.ViewYpos = Player(i).Ypos
            End If
        End If
    Next i
    
    ' rebuild item map
    For i = 1 To UBound(Item)
        If Item(i).flgInUse Then
            ItemMap(Item(i).Xpos, Item(i).Ypos) = i
        End If
    Next i
    
    
    
    Exit Sub
    
Error_modFile_Load:
    MsgBox "Error_modFile_Load : " & Err.Description
End Sub
