Attribute VB_Name = "modMonster"
' modMonster.bas

''''''''''''''''''''''''''''''''''''''''''''''''''''

' Revisions Notes

' June 6, 2005
'  - init uses external file

''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit


Type MonsterDefType
    Name As String
    
    Level As Long
    
    Image As Integer
    
    Life As Long
    Stamina As Long
    
    SightRange As Long
    
    Melee As Long
    
    DeadItemID As Integer
    
    SoundID As Byte
    
End Type

Global MonsterDef() As MonsterDefType


' code submitted by Jon, 6/6/05
Sub modMonster_Init()
    On Error GoTo errHandle
    
    Dim lFileNum As Long
    Dim strData As String
    Dim iNumber As Integer
    
    lFileNum = FreeFile
    
    Open App.Path & "\monster.ini" For Input As #lFileNum
    
    ' get count/max first
    Do Until EOF(lFileNum)
        Line Input #lFileNum, strData
    
        If UCase$(Left$(strData, 8)) = "MONSTER=" Then
            If iNumber < Int(Trim$(Right$(strData, Len(strData) - 8))) Then
                iNumber = Int(Trim$(Right$(strData, Len(strData) - 8)))
            End If
        End If
    Loop
    
    ReDim MonsterDef(1 To iNumber)
    
    iNumber = 0
    
    ' rewind to beginning of file
    Seek #lFileNum, 1
    
    ' ok, now load them all up
    Do Until EOF(lFileNum)
        Line Input #lFileNum, strData
    
        If Left$(strData, 1) = ";" Or Len(Trim$(strData)) = 0 Then
            ' remark, just ignore
        ElseIf UCase$(Left$(strData, 8)) = "MONSTER=" Then
            'Set the current monster number
            iNumber = Int(Trim$(Right$(strData, Len(strData) - 8)))
        
        ElseIf UCase$(Left$(strData, 5)) = "NAME=" Then
            MonsterDef(iNumber).Name = Trim$(Right$(strData, Len(strData) - 5))
        
        ElseIf UCase$(Left$(strData, 6)) = "IMAGE=" Then
            MonsterDef(iNumber).Image = Int(Trim$(Right$(strData, Len(strData) - 6)))
        
        ElseIf UCase$(Left$(strData, 6)) = "LEVEL=" Then
            MonsterDef(iNumber).Level = Int(Trim$(Right$(strData, Len(strData) - 6)))
        
        ElseIf UCase$(Left$(strData, 5)) = "LIFE=" Then
            MonsterDef(iNumber).Life = Int(Trim$(Right$(strData, Len(strData) - 5)))
        
        ElseIf UCase$(Left$(strData, 8)) = "STAMINA=" Then
            MonsterDef(iNumber).Stamina = Int(Trim$(Right$(strData, Len(strData) - 8)))
        
        ElseIf UCase$(Left$(strData, 11)) = "SIGHTRANGE=" Then
            MonsterDef(iNumber).SightRange = Int(Trim$(Right$(strData, Len(strData) - 11)))
        
        ElseIf UCase$(Left$(strData, 6)) = "MELEE=" Then
            MonsterDef(iNumber).Melee = Int(Trim$(Right$(strData, Len(strData) - 6)))
        
        ElseIf UCase$(Left$(strData, 9)) = "DEADITEM=" Then
            'Check if a number was entered?
            If IsNumeric(Trim$(Right$(strData, Len(strData) - 9))) = True Then
                MonsterDef(iNumber).DeadItemID = Int(Trim$(Right$(strData, Len(strData) - 9)))
            Else
                MonsterDef(iNumber).DeadItemID = modItem_ID(Trim$(Right$(strData, Len(strData) - 9)))
            End If
        
        ElseIf UCase$(Left$(strData, 8)) = "SOUNDID=" Then
            MonsterDef(iNumber).SoundID = Int(Trim$(Right$(strData, Len(strData) - 8)))
        
        Else
            'Unknown command found
            MsgBox "Unknown line found in monster.ini" & vbCrLf & strData, vbExclamation, "WARNING!!!!"
        
        End If
        
    Loop
    
    Close #lFileNum

    Exit Sub

errHandle:
    MsgBox "Error_modMonster_Init: " & Err.Description & " Monster#=" & iNumber
End Sub


''' original init
'''Sub modMonster_Init()
'''
'''    ReDim MonsterDef(10)
'''
'''    MonsterDef(1).Name = "Giant Rat"
'''    MonsterDef(1).Level = 1
'''    MonsterDef(1).Image = 1
'''    MonsterDef(1).Life = 20
'''    MonsterDef(1).Stamina = 40
'''    MonsterDef(1).SightRange = 3
'''    MonsterDef(1).Melee = 5
'''    MonsterDef(1).DeadItemID = modItem_ID("Dead Giant Rat")
'''    MonsterDef(1).SoundID = SOUND_GIANT_RAT
'''
'''
'''    MonsterDef(2).Name = "Asp"
'''    MonsterDef(2).Level = 2
'''    MonsterDef(2).Image = 2
'''    MonsterDef(2).Life = 30
'''    MonsterDef(2).Stamina = 60
'''    MonsterDef(2).SightRange = 4
'''    MonsterDef(2).Melee = 10
'''    MonsterDef(2).DeadItemID = modItem_ID("Dead Asp")
'''    MonsterDef(2).SoundID = SOUND_SNAKEHISS
'''
'''
'''End Sub


Sub modMonster_Process()
    On Error GoTo Error_modMonster_Process

    Static Count As Long

    Dim i As Long, Start1 As Long, Stop1 As Long, Step1 As Long
    
    Count = Count + 1
    
    If Count = 1 Then
        Start1 = 1
        Stop1 = UBound(Player)
        Step1 = 1
    Else
        Start1 = UBound(Player)
        Stop1 = 1
        Step1 = -1
        
        Count = 0
    End If
    
    
    For i = Start1 To Stop1 Step Step1
        
        If Player(i).flgInUse And Player(i).ID > 0 Then
                
            If Game.pIndex = 0 Then
                modMonster_Home i
            ElseIf modMap_Dist(Player(i).Xpos, Player(i).Ypos, Player(Game.pIndex).Xpos, Player(Game.pIndex).Ypos) <= Player(i).SightRange Then
                
                If modMap_Open_Sight_Line(Player(i).Xpos, Player(i).Ypos, Player(Game.pIndex).Xpos, Player(Game.pIndex).Ypos) Then
                    ' attack
                    modMonster_Attack i
                Else
                    ' move to home spot
                    modMonster_Home i
                End If
            Else
                modMonster_Home i
            End If
        
        End If
    
    Next i

    Exit Sub
    
Error_modMonster_Process:
    MsgBox "Error_modMonster_Process : " & Err.Description
End Sub


Sub modMonster_Attack(pIndex As Long)
    On Error GoTo Error_modMonster_Attack


    Dim Direction As Integer

    Direction = modMap_Direction(Player(pIndex).Xpos, Player(pIndex).Ypos, Player(Game.pIndex).Xpos, Player(Game.pIndex).Ypos)

    ' see if close enough
    If modMap_Dist(Player(pIndex).Xpos, Player(pIndex).Ypos, Player(Game.pIndex).Xpos, Player(Game.pIndex).Ypos) > 1 Then
        ' move closer
        
        ' try the direction
        If Not modPlayer_Move(pIndex, Direction) Then
        
            ' direction blocked, get an alt one and try it
            Direction = modMap_AltDirection(Direction)
            
            modPlayer_Move pIndex, Direction
        End If
    Else
        ' ok, attack!
        
        Player(pIndex).Facing = Direction
        
        modPlayer_Attack pIndex, Game.pIndex
                
    End If

    Exit Sub
    
Error_modMonster_Attack:
    MsgBox "Error_modMonster_Attack : " & Err.Description
End Sub


Sub modMonster_Home(pIndex As Long)
    On Error GoTo Error_modMonster_Home

    Dim Direction As Integer

    ' see if close enough
    If Player(pIndex).Xpos <> Player(pIndex).HomeXpos Or Player(pIndex).Ypos <> Player(pIndex).HomeYpos Then
        
        ' move to home
        Direction = modMap_Direction(Player(pIndex).Xpos, Player(pIndex).Ypos, Player(pIndex).HomeXpos, Player(pIndex).HomeYpos)
        
        ' try the direction
        If Not modPlayer_Move(pIndex, Direction) Then
        
            ' direction blocked, get an alt one and try it
            Direction = modMap_AltDirection(Direction)
            
            modPlayer_Move pIndex, Direction
        End If
    End If
    
    Exit Sub
    
Error_modMonster_Home:
    MsgBox "Error_modMonster_Home : " & Err.Description
End Sub
