Attribute VB_Name = "modSkill"
Option Explicit

Global Const MAX_SKILLS As Long = 10

Global Const SKILL_MELEE As Long = 1



Type SkillDefType
    Name As String
    Description As String
    
End Type

Global SkillDef(1 To MAX_SKILLS) As SkillDefType


Type SkillType
    flgTrained As Boolean
    
    Base As Long
    
    RaiseCount As Long
        
    XP As Long

End Type



Sub modSkill_Init()
    On Error GoTo Error_modSkill_Init

    SkillDef(SKILL_MELEE).Name = "Melee"
    SkillDef(SKILL_MELEE).Description = "Ability to use melee weapons to attack and defend."
    
    'SkillDef(SKILL_DEFEND).Name = "Defend"
    
    Exit Sub
    
Error_modSkill_Init:
    MsgBox "Error_modSkill_Init : " & Err.Description
End Sub


Function modSkill_Value(pIndex As Long, sIndex As Long) As Long
    On Error GoTo Error_modSkill_Value

    ' this is where you apply boosts or de-boosts to the base value
    
    If Not Player(pIndex).Skill(sIndex).flgTrained Then Exit Function
    
    modSkill_Value = Player(pIndex).Skill(sIndex).Base

    Exit Function
    
Error_modSkill_Value:
    MsgBox "Error_modSkill_Value : " & Err.Description
End Function


Function modSkill_Roll(pIndex As Long, sIndex As Long) As Long
    On Error GoTo Error_modSkill_Roll
    
    Dim Roll As Long
    
    Roll = modSkill_Value(pIndex, sIndex)
    
    ' do a simple +/- 10
    
    modSkill_Roll = Roll + Rnd * 20 - 10
                
    Exit Function
    
Error_modSkill_Roll:
    MsgBox "Error_modSkill_Roll : " & Err.Description
End Function


Sub modSkill_Raise_XP(pIndex As Long, sIndex As Long, XP As Long, Optional flgGiveXP As Boolean = True)
    On Error GoTo Error_modSkill_Raise_XP

    If Not Player(pIndex).Skill(sIndex).flgTrained Then Exit Sub
    
    Player(pIndex).Skill(sIndex).XP = Player(pIndex).Skill(sIndex).XP - XP
    
    If Player(pIndex).Skill(sIndex).XP <= 0 Then
        ' increase skill base
        Player(pIndex).Skill(sIndex).Base = Player(pIndex).Skill(sIndex).Base + 1
        
        Player(pIndex).Skill(sIndex).RaiseCount = Player(pIndex).Skill(sIndex).RaiseCount + 1
        
        ' figure out amount of XP needed for next raise
        Dim fact As Single
        fact = Player(pIndex).Skill(sIndex).RaiseCount / 25 + 5
       
        Player(pIndex).Skill(sIndex).XP = ((fact * Player(pIndex).Skill(sIndex).RaiseCount ^ 2) + Player(pIndex).Skill(sIndex).RaiseCount * fact) + 100
                
        If pIndex = Game.pIndex Then
            modMessage_Add Trim$(Player(pIndex).Name) & "'s " & SkillDef(sIndex).Name & " skill has improved to " & Player(pIndex).Skill(sIndex).Base & "!", vbGreen
        End If
    End If

    If flgGiveXP Then
        modPlayer_Raise_XP pIndex, XP
    End If

    Exit Sub
    
Error_modSkill_Raise_XP:
    MsgBox "Error_modSkill_Raise_XP : " & Err.Description
End Sub


Sub modSkill_Raise(pIndex As Long, sIndex As Long)
    On Error GoTo Error_modSkill_Raise
   
    If Player(pIndex).Skill(sIndex).XP > Player(pIndex).SpendableXP Then
        If Game.pIndex = pIndex Then
            modMessage_Add "You need " & Player(pIndex).Skill(sIndex).XP & " spendable XP to raise " & SkillDef(sIndex).Name & "!", vbYellow
        End If
        Exit Sub
    End If
    
    Player(pIndex).SpendableXP = Player(pIndex).SpendableXP - Player(pIndex).Skill(sIndex).XP
    
    modSkill_Raise_XP pIndex, sIndex, Player(pIndex).Skill(sIndex).XP, False

    Exit Sub
    
Error_modSkill_Raise:
    MsgBox "Error_modSkill_Raise : " & Err.Description
End Sub
