Attribute VB_Name = "modSound"
Option Explicit

Global Const SOUND_SWISH As Byte = 1
Global Const SOUND_PUNCH As Byte = 2
Global Const SOUND_WALK As Byte = 3
Global Const SOUND_DOOR_OPEN As Byte = 4
Global Const SOUND_DOOR_CLOSE As Byte = 5
Global Const SOUND_GIANT_RAT As Byte = 6
Global Const SOUND_GRUNT As Byte = 7
Global Const SOUND_BEEP1 As Byte = 8
Global Const SOUND_SNAKEHISS As Byte = 9
Global Const SOUND_UP As Byte = 10
Global Const SOUND_DOWN As Byte = 11
Global Const SOUND_READY As Byte = 12
Global Const SOUND_BEEP2 As Byte = 13


Private dx7 As DirectX7
Private ds7 As New clsDirectSound

Private flgSoundEnabled As Boolean


Sub modSound_Clean()
    On Error GoTo Error_modSound_Clean
    
    Set dx7 = Nothing
    
    flgSoundEnabled = False
    
Error_modSound_Clean:
    MsgBox "Error_modSound_Clean : " & Err.Description
End Sub



Sub modSound_Init()
    On Error GoTo Error_modSound_Init
   
    Set dx7 = New DirectX7
  
    If ds7.Init(dx7, frmMain, 13) Then       ' INCREASE the last number when adding sounds
        ' load up sounds
        
        ds7.Load App.Path & "\caneswish.wav", SOUND_SWISH
        ds7.Load App.Path & "\punch.wav", SOUND_PUNCH
        ds7.Load App.Path & "\walk.wav", SOUND_WALK
        ds7.Load App.Path & "\dooropen.wav", SOUND_DOOR_OPEN
        ds7.Load App.Path & "\doorclose.wav", SOUND_DOOR_CLOSE
        
        'ds7.Load App.Path & "\giantrat.wav", SOUND_GIANT_RAT
        ds7.Load App.Path & "\mouse.wav", SOUND_GIANT_RAT
        
        'ds7.Load App.Path & "\grunt.wav", SOUND_GRUNT
        ds7.Load App.Path & "\ow.wav", SOUND_GRUNT
        
        ds7.Load App.Path & "\beep1.wav", SOUND_BEEP1
        ds7.Load App.Path & "\beep2.wav", SOUND_BEEP2
        
        ds7.Load App.Path & "\snakehiss.wav", SOUND_SNAKEHISS
        
        ds7.Load App.Path & "\whistleup.wav", SOUND_UP
        ds7.Load App.Path & "\whistledown.wav", SOUND_DOWN
        ds7.Load App.Path & "\ready.wav", SOUND_READY
                
        '' DONT FORGET TO INCREASE ARRAY!!!! in ds7.init function
        
        flgSoundEnabled = True
    Else
        flgSoundEnabled = False
    End If
    
    Exit Sub
    
Error_modSound_Init:
    MsgBox "Error_modSound_Init : " & Err.Description
End Sub


Sub modSound_Play(SoundNo As Byte, Optional flags As CONST_DSBPLAYFLAGS = DSBPLAY_DEFAULT)
    On Error GoTo Error_modSound_Play
    
    If flgSoundEnabled Then
        ds7.SoundPlay SoundNo, flags
    End If
    
    Exit Sub
    
Error_modSound_Play:
    MsgBox "Error_modSound_Play : " & Err.Description
End Sub

